<!DOCTYPE html>
<html>
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta http-equiv="X-UA-Compatible" content="ie=edge" />
    <title>Slide Project</title>
    <style>
      html,
      body {
        box-sizing: border-box;
        padding: 0;
        margin: 0;
        text-align: center;
      }
      *,
      *:before,
      *:after {
        box-sizing: inherit;
      }
      .clearfix:after {
        content: "";
        display: block;
        clear: both;
        float: none;
      }
      .title {
        margin-bottom: 0;
        text-align: center;
        font-size: 30px;
        color: #333;
      }
      #container {
        width: 1000px;
        margin: auto;
      }
      .slide_wrap {
        position: relative;
        width: 400px;
        margin: auto;
        padding-bottom: 30px;
      }
      .slide_box {
        width: 100%;
        margin: auto;
        overflow-x: hidden;
      }
      .slide_content {
        display: table;
        float: left;
        width: 400px;
        height: 400px;
      }
      .slide_content > p {
        display: table-cell;
        vertical-align: middle;
        text-align: center;
        font-size: 100px;
        font-weight: bold;
        color: #555;
      }
      .slide_content.slide01 {
        background: #ddbdff;
      }
      .slide_content.slide02 {
        background: #9fd6c2;
      }
      .slide_content.slide03 {
        background: #abe2f7;
      }
      .slide_content.slide04 {
        background: #f08c78;
      }
      .slide_content.slide05 {
        background: #fbdb65;
      }
      .slide_btn_box > button {
        position: absolute;
        top: 50%;
        margin-top: -45px;
        width: 60px;
        height: 60px;
        font-size: 16px;
        color: #999;
        background: none;
        border: 1px solid #ddd;
        cursor: pointer;
      }
      .slide_btn_box > .slide_btn_prev {
        left: -100px;
      }
      .slide_btn_box > .slide_btn_next {
        right: -100px;
      }
      .slide_pagination {
        position: absolute;
        left: 50%;
        bottom: 0;
        list-style: none;
        margin: 0;
        padding: 0;
        transform: translateX(-50%);
      }
      /* dot_active 가 추가 되면, 배경색이 0.3 초뒤에 바뀜*/
      .slide_pagination .dot {
        display: inline-block;
        width: 15px;
        height: 15px;
        margin: 0 5px;
        overflow: hidden;
        background: #ddd;
        border-radius: 50%;
        transition: 0.3s;
      }
      .slide_pagination .dot.dot_active {
        background: #333;
      }
      .slide_pagination .dot a {
        display: block;
        width: 100%;
        height: 100%;
      }
    </style>
  </head>
  <body>
    <div id="container">
      <div class="slide_wrap">
        <div class="slide_box">
          <div class="slide_list clearfix">
            <div class="slide_content slide01">
              <p>1</p>
            </div>
            <div class="slide_content slide02">
              <p>2</p>
            </div>
            <div class="slide_content slide03">
              <p>3</p>
            </div>
            <div class="slide_content slide04">
              <p>4</p>
            </div>
            <div class="slide_content slide05">
              <p>5</p>
            </div>
          </div>
          <!-- // .slide_list -->
        </div>
        <!-- // .slide_box -->
        <div class="slide_btn_box">
          <button type="button" class="slide_btn_prev">Prev</button>
          <button type="button" class="slide_btn_next">Next</button>
        </div>
        <!-- // .slide_btn_box -->
        <ul class="slide_pagination"></ul>
        <!-- // .slide_pagination -->
      </div>
      <!-- // .slide_wrap -->
    </div>
    <script>
      (function () {
        const slideList = document.querySelector(".slide_list");
        const slideContents = document.querySelectorAll(".slide_content");
        const slideBtnNext = document.querySelector(".slide_btn_next");
        const slideBtnPrev = document.querySelector(".slide_btn_prev");
        const pagination = document.querySelector(".slide_pagination");

        const slideLen = slideContents.length;
        const slideWidth = 400;
        const slideSpeed = 300;
        const startNum = 0;
        // slide-box 가 보여주는 너비는 400 밖에 안되고
        // slide-list 는 2800 의 너비를 가지고 있는 상황
        // slide-box 는 너비 400 이상은 overflow-x: hidden
        // 으로 가리고 있으므로, 안보임
        slideList.style.width = slideWidth * (slideLen + 2) + "px";

        // 무한 회전을 위해, 페이크로 앞뒤에 넣어줌
        let firstChild = slideList.firstElementChild;
        let lastChild = slideList.lastElementChild;
        let clonedFirst = firstChild.cloneNode(true);
        let clonedLast = lastChild.cloneNode(true);
        slideList.appendChild(clonedFirst);
        slideList.insertBefore(clonedLast, slideList.firstElementChild);

        // pagination 점들 넣기
        let pageChild = "";
        for (let i = 0; i < slideLen; ++i) {
          pageChild += '<li class="dot';
          pageChild += i === startNum ? " dot_active" : "";
          pageChild += '" data-index="' + i + '"><a href="#"></a></li>';
        }
        pagination.innerHTML = pageChild;
        const pageDots = document.querySelectorAll(".dot");

        // 움직일 수 있도록 세팅해두기
        slideList.style.transform = "translate3d(-" + slideWidth * (startNum + 1) + "px, 0px, 0px)";

        // 액티브 스크린 세팅
        let curIndex = startNum;
        let curSlide = slideContents[curIndex];
        curSlide.classList.add("slide_active");

        //
        slideBtnNext.addEventListener("click", function () {
          // 다음 버튼을 누르면
          // slideList.style 을 변경하므로
          // transform 이 발동됨
          if (curIndex <= slideLen - 1) {
            slideList.style.transition = slideSpeed + "ms";
            slideList.style.transform = "translate3d(-" + slideWidth * (curIndex + 2) + "px, 0px, 0px)";
          }
          // 맨 끝 슬라이드였다면, 페이크 슬라이드에서 진짜 슬라이드로
          // 교체 진행
          if (curIndex == slideLen - 1) {
            setTimeout(function () {
              slideList.style.transition = "0ms";
              slideList.style.transform = "translate3d(-" + slideWidth + "px, 0px, 0px)";
            }, slideSpeed);
            curIndex = -1;
          }

          // 현재 슬라이드의 액티브 속성 제거
          curSlide.classList.remove("slide_active");

          // 페이지점의 액티브 속성 제거
          pageDots[curIndex === -1 ? slideLen - 1 : curIndex].classList.remove("dot_active");

          // 현재 슬라이드 세팅
          curSlide = slideContents[++curIndex];

          // 현재 슬라이드에 액티브 속성 추가
          curSlide.classList.add("slide_active");

          // 페이지점의 액티브 속성 추가
          pageDots[curIndex].classList.add("dot_active");
        });

        slideBtnPrev.addEventListener("click", function () {
          if (curIndex >= 0) {
            slideList.style.transition = slideSpeed + "ms";
            slideList.style.transform = "translate3d(-" + slideWidth * curIndex + "px, 0px, 0px)";
          }

          if (curIndex == 0) {
            setTimeout(function () {
              slideList.style.transition = "0ms";
              slideList.style.transform = "translate3d(-" + slideWidth * slideLen + "px, 0px, 0px)";
            }, slideSpeed);
            curIndex = slideLen;
          }

          // 속성 제거
          curSlide.classList.remove("slide_active");
          pageDots[curIndex == slideLen ? 0 : curIndex].classList.remove("dot_active");

          // 새 위치에 속성 추가
          curSlide = slideContents[--curIndex];
          curSlide.classList.add("slide_active");
          pageDots[curIndex].classList.add("dot_active");
        });

        // 점 하나 하나에 리스너 달기
        let curDot;
        Array.prototype.forEach.call(pageDots, function (dot, i) {
          dot.addEventListener("click", function (e) {
            e.preventDefault();

            // 현재 위치의 점의 액티브 속성 제거
            curDot = document.querySelector(".dot_active");
            curDot.classList.remove("dot_active");

            // 리스너의 this 는 주체 객체를 의미
            curDot = this;
            this.classList.add("dot_active");

            // 각 점마다 슬라이드의 인덱스 값이 있음
            curSlide.classList.remove("slide_active");
            curIndex = Number(this.getAttribute("data-index"));

            // 액티브 슬라이드 변경
            curSlide = slideContents[curIndex];
            curSlide.classList.add("slide_active");

            // 슬라이드 리스트의 스타일 변경을 통한, transform 유발
            slideList.style.transition = slideSpeed + "ms";
            slideList.style.transform = "translate3d(-" + slideWidth * (curIndex + 1) + "px, 0px, 0px)";
          });
        });
      })();
    </script>
  </body>
</html>
